//---------------------------------------------------------------------------
#include "Unit1.h"
#include <fstream> 
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TSimpleTestService *SimpleTestService;
//---------------------------------------------------------------------------
__fastcall TSimpleTestService::TSimpleTestService(TComponent* Owner)
	: TService(Owner)
{
}

TServiceController __fastcall TSimpleTestService::GetServiceController(void)
{
	return (TServiceController) ServiceController;
}

void __stdcall ServiceController(unsigned CtrlCode)
{
	SimpleTestService->Controller(CtrlCode);
}
//---------------------------------------------------------------------------

void __fastcall TSimpleTestService::ServiceStart(TService *Sender, bool &Started)
{
	ServerSocket1->Port = 33333;
	ServerSocket1->Active = true;
}
//---------------------------------------------------------------------------

void __fastcall TSimpleTestService::ServiceStop(TService *Sender, bool &Stopped)
{
	ServerSocket1->Active = true;
}
//---------------------------------------------------------------------------

void __fastcall TSimpleTestService::ServerSocket1ClientRead(TObject *Sender,
			TCustomWinSocket *Socket)
{
	AnsiString t = Socket->ReceiveText();
	std::ofstream o("log.log", std::ios::out | std::ios::app);
	if(!o) exit(EXIT_FAILURE);
	o << DateTimeToStr(Now()).c_str() << " " << t.c_str() << "/n";
}
//---------------------------------------------------------------------------
void __fastcall TSimpleTestService::ServerSocket1ClientConnect(TObject *Sender,
			TCustomWinSocket *Socket)
{
	AnsiString t = Socket->RemoteHost;
	std::ofstream o("log.log", std::ios::out | std::ios::app);
	if(!o) exit(EXIT_FAILURE);
	o << DateTimeToStr(Now()).c_str() << " " <<  t.c_str() << " /n";
}
//---------------------------------------------------------------------------
void __fastcall TSimpleTestService::ServerSocket1ClientDisconnect(TObject *Sender,
			TCustomWinSocket *Socket)
{
	AnsiString t = Socket->RemoteHost;
	std::ofstream o("log.log", std::ios::out | std::ios::app);
	if(!o) exit(EXIT_FAILURE);
	o << DateTimeToStr(Now()).c_str() << " " <<  t.c_str() << " /n";
}
//---------------------------------------------------------------------------
