//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <SvcMgr.hpp>
#include <vcl.h>
#include <ScktComp.hpp>
//---------------------------------------------------------------------------
class TSimpleTestService : public TService
{
__published:    // IDE-managed Components
	TServerSocket *ServerSocket1;
	void __fastcall ServiceStart(TService *Sender, bool &Started);
	void __fastcall ServiceStop(TService *Sender, bool &Stopped);
	void __fastcall ServerSocket1ClientRead(TObject *Sender,
          TCustomWinSocket *Socket);
	void __fastcall ServerSocket1ClientConnect(TObject *Sender,
          TCustomWinSocket *Socket);
	void __fastcall ServerSocket1ClientDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
private:        // User declarations
public:         // User declarations
	__fastcall TSimpleTestService(TComponent* Owner);
	TServiceController __fastcall GetServiceController(void);

	friend void __stdcall ServiceController(unsigned CtrlCode);
};
//---------------------------------------------------------------------------
extern PACKAGE TSimpleTestService *SimpleTestService;
//---------------------------------------------------------------------------
#endif
